diff --git a/target/linux/lantiq/dts/P2812HNUF1.dts b/target/linux/lantiq/dts/P2812HNUF1.dts
index 24ded3e..4dcaf27 100644
--- a/target/linux/lantiq/dts/P2812HNUF1.dts
+++ b/target/linux/lantiq/dts/P2812HNUF1.dts
@@ -42,65 +42,4 @@
 		compatible = "ralink,eeprom";
 		ralink,eeprom = "RT3062.eeprom";
 	};
-
-	gpio-leds {
-		compatible = "gpio-leds";
-
-		internet_red {				/* red */
-			label = "internet_red";
-			gpios = <&stp 16 1>;
-		};
-		internet_green {
-			label = "internet_green";	/* green */
-			gpios = <&stp 17 1>;
-		};
-		dsl {
-			label = "dsl";
-			gpios = <&stp 18 1>;
-		};
-		dsl2 {
-			label = "dsl2";
-			gpios = <&stp 19 1>;
-		};
-		wireless_red {				/* red */
-			label = "wireless_red";
-			gpios = <&stp 20 1>;
-		};
-		wireless_green {			/* green */
-			label = "wireless_green";
-			gpios = <&stp 21 1>;
-		};
-		power {					/* red */
-			label = "power";
-			gpios = <&stp 22 1>;
-		};
-		power2 {				/* green */
-			label = "power2";
-			gpios = <&stp 23 1>;
-		};
-		usb1 {					/* green */
-			label = "usb1";
-			gpios = <&gpio 38 1>;
-		};
-		usb2 {					/* green */
-			label = "usb2";
-			gpios = <&gpio 44 1>;
-		};
-		phone1 {				/* green */
-			label = "phone1";
-			gpios = <&gpio 11 1>;
-		};
-		phone1warn {				/* red */
-			label = "phone1warn";
-			gpios = <&gpio 12 1>;
-		};
-		phone2warn {				/* red */
-			label = "phone2warn";
-			gpios = <&gpio 26 1>;
-		};
-		phone2 {				/* green */
-			label = "phone2";
-			gpios = <&gpio 28 1>;
-		};
-	};
 };
diff --git a/target/linux/lantiq/dts/P2812HNUF3.dts b/target/linux/lantiq/dts/P2812HNUF3.dts
index 5d25c3c..a293f59 100644
--- a/target/linux/lantiq/dts/P2812HNUF3.dts
+++ b/target/linux/lantiq/dts/P2812HNUF3.dts
@@ -53,57 +53,4 @@
 		compatible = "ralink,eeprom";
 		ralink,eeprom = "RT3092.eeprom";
 	};
-
-	gpio-leds {
-		compatible = "gpio-leds";
-
-		internet2 {
-			label = "internet2";
-			gpios = <&stp 16 1>;
-		};
-		internet {
-			label = "internet";
-			gpios = <&stp 17 1>;
-		};
-		dsl {
-			label = "dsl";
-			gpios = <&stp 18 1>;
-		};
-		dsl2 {
-			label = "dsl2";
-			gpios = <&stp 19 1>;
-		};
-		wireless_red {
-			label = "wireless_red";
-			gpios = <&stp 20 1>;
-		};
-		wireless_green {
-			label = "wireless_green";
-			gpios = <&stp 21 1>;
-		};
-		power2 {
-			label = "power2";
-			gpios = <&stp 22 1>;
-		};
-		power {
-			label = "power";
-			gpios = <&stp 23 1>;
-		};
-		phone1 {
-			label = "phone1";
-			gpios = <&gpio 11 1>;
-		};
-		phone1warn {
-			label = "phone1warn";
-			gpios = <&gpio 12 1>;
-		};
-		phone2 {
-			label = "phone2";
-			gpios = <&gpio 28 1>;
-		};
-		phone2warn {
-			label = "phone2warn";
-			gpios = <&gpio 26 1>;
-		};
-	};
 };
diff --git a/target/linux/lantiq/dts/P2812HNUFX.dtsi b/target/linux/lantiq/dts/P2812HNUFX.dtsi
index d93e862..8c10acc 100644
--- a/target/linux/lantiq/dts/P2812HNUFX.dtsi
+++ b/target/linux/lantiq/dts/P2812HNUFX.dtsi
@@ -259,4 +259,65 @@
 			linux,code = <0xf7>;
 		};
 	};
+
+	gpio-leds {
+		compatible = "gpio-leds";
+
+		internet_red {				/* red */
+			label = "internet_red";
+			gpios = <&stp 16 1>;
+		};
+		internet_green {
+			label = "internet_green";	/* green */
+			gpios = <&stp 17 1>;
+		};
+		dsl {
+			label = "dsl";
+			gpios = <&stp 18 1>;
+		};
+		dsl2 {
+			label = "dsl2";
+			gpios = <&stp 19 1>;
+		};
+		wireless_red {				/* red */
+			label = "wireless_red";
+			gpios = <&stp 20 1>;
+		};
+		wireless_green {			/* green */
+			label = "wireless_green";
+			gpios = <&stp 21 1>;
+		};
+		power {					/* red */
+			label = "power";
+			gpios = <&stp 22 1>;
+		};
+		power2 {				/* green */
+			label = "power2";
+			gpios = <&stp 23 1>;
+		};
+		usb1 {					/* green */
+			label = "usb1";
+			gpios = <&gpio 38 1>;
+		};
+		usb2 {					/* green */
+			label = "usb2";
+			gpios = <&gpio 44 1>;
+		};
+		phone1 {				/* green */
+			label = "phone1";
+			gpios = <&gpio 11 1>;
+		};
+		phone1warn {				/* red */
+			label = "phone1warn";
+			gpios = <&gpio 12 1>;
+		};
+		phone2warn {				/* red */
+			label = "phone2warn";
+			gpios = <&gpio 26 1>;
+		};
+		phone2 {				/* green */
+			label = "phone2";
+			gpios = <&gpio 28 1>;
+		};
+	};
 };