diff --git a/target/linux/brcm47xx/generic/profiles/00-default.mk b/target/linux/brcm47xx/generic/profiles/00-default.mk
new file mode 100644
index 0000000..fc35e6d
--- /dev/null
+++ b/target/linux/brcm47xx/generic/profiles/00-default.mk
@@ -0,0 +1,17 @@
+#
+# Copyright (C) 2013 OpenWrt.org
+#
+# This is free software, licensed under the GNU General Public License v2.
+# See /LICENSE for more information.
+#
+
+define Profile/Default
+  NAME:=Default package set
+  PROFILE_SKIP_DEFAULT:=1
+endef
+
+define Profile/Default/Description
+	Default package set compatible with most boards.
+endef
+$(eval $(call Profile,Default))
+
diff --git a/target/linux/brcm47xx/generic/profiles/01-all.mk b/target/linux/brcm47xx/generic/profiles/01-all.mk
new file mode 100644
index 0000000..0c750e2
--- /dev/null
+++ b/target/linux/brcm47xx/generic/profiles/01-all.mk
@@ -0,0 +1,18 @@
+#
+# Copyright (C) 2013 OpenWrt.org
+#
+# This is free software, licensed under the GNU General Public License v2.
+# See /LICENSE for more information.
+#
+
+define Profile/All
+  NAME:=All Profiles
+  PROFILE_SKIP_SINGLE:=1
+endef
+
+define Profile/All/Description
+	Build images for all profiles
+endef
+
+$(eval $(call Profile,All))
+
diff --git a/target/linux/brcm47xx/image/Makefile b/target/linux/brcm47xx/image/Makefile
index 782beef..19e27e9 100644
--- a/target/linux/brcm47xx/image/Makefile
+++ b/target/linux/brcm47xx/image/Makefile
@@ -355,7 +355,7 @@ define Image/Build/Initramfs
 endef
 
 # $(1): filesystem type.
-define Image/Build
+define Image/Build/Default
 	$(STAGING_DIR_HOST)/bin/trx \
 		-m 33554432 \
 		-o $(BIN_DIR)/$(IMG_PREFIX)-$(1).trx \
@@ -381,4 +381,8 @@ ifneq ($(CONFIG_TARGET_ROOTFS_INITRAMFS),)
 endif
 endef
 
+define Image/Build
+	$(if $(filter-out All,$(2)),$(call Image/Build/Default,$(1),$(2)))
+endef
+
 $(eval $(call BuildImage))
diff --git a/target/linux/brcm47xx/legacy/profiles/00-default.mk b/target/linux/brcm47xx/legacy/profiles/00-default.mk
new file mode 100644
index 0000000..fc35e6d
--- /dev/null
+++ b/target/linux/brcm47xx/legacy/profiles/00-default.mk
@@ -0,0 +1,17 @@
+#
+# Copyright (C) 2013 OpenWrt.org
+#
+# This is free software, licensed under the GNU General Public License v2.
+# See /LICENSE for more information.
+#
+
+define Profile/Default
+  NAME:=Default package set
+  PROFILE_SKIP_DEFAULT:=1
+endef
+
+define Profile/Default/Description
+	Default package set compatible with most boards.
+endef
+$(eval $(call Profile,Default))
+
diff --git a/target/linux/brcm47xx/legacy/profiles/01-all.mk b/target/linux/brcm47xx/legacy/profiles/01-all.mk
new file mode 100644
index 0000000..0c750e2
--- /dev/null
+++ b/target/linux/brcm47xx/legacy/profiles/01-all.mk
@@ -0,0 +1,18 @@
+#
+# Copyright (C) 2013 OpenWrt.org
+#
+# This is free software, licensed under the GNU General Public License v2.
+# See /LICENSE for more information.
+#
+
+define Profile/All
+  NAME:=All Profiles
+  PROFILE_SKIP_SINGLE:=1
+endef
+
+define Profile/All/Description
+	Build images for all profiles
+endef
+
+$(eval $(call Profile,All))
+
diff --git a/target/linux/brcm47xx/mips74k/profiles/00-default.mk b/target/linux/brcm47xx/mips74k/profiles/00-default.mk
new file mode 100644
index 0000000..fc35e6d
--- /dev/null
+++ b/target/linux/brcm47xx/mips74k/profiles/00-default.mk
@@ -0,0 +1,17 @@
+#
+# Copyright (C) 2013 OpenWrt.org
+#
+# This is free software, licensed under the GNU General Public License v2.
+# See /LICENSE for more information.
+#
+
+define Profile/Default
+  NAME:=Default package set
+  PROFILE_SKIP_DEFAULT:=1
+endef
+
+define Profile/Default/Description
+	Default package set compatible with most boards.
+endef
+$(eval $(call Profile,Default))
+
diff --git a/target/linux/brcm47xx/mips74k/profiles/01-all.mk b/target/linux/brcm47xx/mips74k/profiles/01-all.mk
new file mode 100644
index 0000000..0c750e2
--- /dev/null
+++ b/target/linux/brcm47xx/mips74k/profiles/01-all.mk
@@ -0,0 +1,18 @@
+#
+# Copyright (C) 2013 OpenWrt.org
+#
+# This is free software, licensed under the GNU General Public License v2.
+# See /LICENSE for more information.
+#
+
+define Profile/All
+  NAME:=All Profiles
+  PROFILE_SKIP_SINGLE:=1
+endef
+
+define Profile/All/Description
+	Build images for all profiles
+endef
+
+$(eval $(call Profile,All))
+